import { CloudProviderEnum, ClusterDef, IngressDef, RootMap } from "../apis/codiac-api/contracts";
import { ClusterCaptureDef } from "../codiac-entities/cluster-capture-def";
/** A UI implementation for declaring an image registry. */
export interface IClusterConfigurator {
    get cloudProvider(): CloudProviderEnum;
    defineCluster(workingModel: Partial<ClusterDef>, defaults?: Partial<ClusterDef>): Promise<{
        spec: ClusterDef;
        defaults: Partial<ClusterDef>;
    }>;
    defineClusterCaptureParams(initial: Partial<ClusterDef>, rootMap: RootMap, defaults?: Partial<ClusterDef>): Promise<{
        spec: ClusterCaptureDef;
        defaults: Partial<ClusterDef>;
    }>;
    promptForIngressSpec(current?: Partial<IngressDef>): Promise<IngressDef | undefined>;
}
